diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
index 000e24353..9abaa9006 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
@@ -1,8 +1,9 @@
 package net.minecraft.core.block;
 
 import java.util.Random;
+
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -10,38 +11,39 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicGrass extends BlockLogic
-{
+public class BlockLogicGrass extends BlockLogic {
     public final @NotNull Block<?> dirt;
-    public BlockLogicGrass(@NotNull Block<?> block, @NotNull Block<?> dirt)
-    {
-        super(block, Material.grass);
+
+    public BlockLogicGrass(@NotNull Block<?> block, @NotNull Block<?> dirt) {
+        super(block, Materials.GRASS);
         block.setTicking(true);
         this.dirt = dirt;
     }
 
     @Override
-    public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick)
-    {
-        if(world.isClientSide) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (world.isClientSide) {
             return;
         }
-        TilePos up = tilePos.up();
-        if(world.getBlockLightValue(up) < 4 && Blocks.lightBlock[world.getBlockId(up)] > 2) {
+        TilePos queryPos = new TilePos();
+        if (world.getBlockLightValue(tilePos.up(queryPos)) < 4 && Blocks.lightBlock[world.getBlockId(tilePos.up(queryPos))] > 2) {
             world.setBlockIdNotify(tilePos, this.dirt.id());
-        } else if(world.getBlockLightValue(up) >= 9) {
-            TilePos p = new TilePos(tilePos);
-            for(int i = 0; i < 4; i++) {
-                p.set((tilePos.x + rand.nextInt(3)) - 1, (tilePos.y + rand.nextInt(5)) - 3, (tilePos.x + rand.nextInt(3)) - 1);
-                TilePos pUp = p.up();
-                if (world.getBlockId(p) == this.dirt.id() && world.getBlockLightValue(pUp) >= 4 && Blocks.lightBlock[world.getBlockId(pUp)] <= 2) {
-                    world.setBlockIdNotify(p, this.block.id());
+        } else if (world.getBlockLightValue(tilePos.up(queryPos)) >= 9) {
+            for (int i = 0; i < 4; i++) {
+                int checkX = (tilePos.x() + rand.nextInt(3)) - 1;
+                int checkY = (tilePos.y() + rand.nextInt(5)) - 3;
+                int checkZ = (tilePos.x() + rand.nextInt(3)) - 1;
+                if (world.getBlockId(queryPos.set(checkX, checkY, checkZ)) == this.dirt.id() &&
+                    world.getBlockLightValue(queryPos.set(checkX, checkY + 1, checkZ)) >= 4 &&
+                    Blocks.lightBlock[world.getBlockId(queryPos.set(checkX, checkY + 1, checkZ))] <= 2) {
+                    world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
                 }
             }
-            if (world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getBlockId(up) == 0 && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().growFlowers && rand.nextInt(256) == 0) {
+            if (world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getBlockId(tilePos.up(queryPos)) == 0 && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().growFlowers && rand.nextInt(256) == 0) {
                 int idToSpawn = 0;
                 int r = rand.nextInt(400);
 
@@ -50,8 +52,8 @@ public class BlockLogicGrass extends BlockLogic
                 } else if (r < 41) {
                     idToSpawn = Blocks.FLOWER_YELLOW.id();
                 } else if (r < 60) {
-                    Biome biome = world.getBlockBiome(up);
-                    if (biome == Biomes.OVERWORLD_BIRCH_FOREST || biome == Biomes.OVERWORLD_SEASONAL_FOREST){
+                    Biome biome = world.getBlockBiome(tilePos.up(queryPos));
+                    if (biome == Biomes.OVERWORLD_BIRCH_FOREST || biome == Biomes.OVERWORLD_SEASONAL_FOREST) {
                         idToSpawn = Blocks.FLOWER_PINK.id();
                     } else if (biome == Biomes.OVERWORLD_MEADOW || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_SHRUBLAND) {
                         idToSpawn = Blocks.FLOWER_PURPLE.id();
@@ -59,14 +61,14 @@ public class BlockLogicGrass extends BlockLogic
                         idToSpawn = Blocks.FLOWER_LIGHT_BLUE.id();
                     }
                 } else {
-                    if(rand.nextInt(8) == 0) {
+                    if (rand.nextInt(8) == 0) {
                         idToSpawn = Blocks.TALLGRASS_FERN.id();
-                    }else {
+                    } else {
                         idToSpawn = Blocks.TALLGRASS.id();
                     }
                 }
 
-                world.setBlockIdNotify(up, idToSpawn);
+                world.setBlockIdNotify(tilePos.up(queryPos), idToSpawn);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
index 4a1548ace..cf6f6c31c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
@@ -2,12 +2,14 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -16,7 +18,7 @@ import java.util.Random;
 public class BlockLogicIce extends BlockLogicTransparent {
 
     public BlockLogicIce(@NotNull Block<?> block) {
-        super(block, Material.ice);
+        super(block, Materials.ICE);
         block.friction = 0.98F;
         block.setTicking(true);
     }
@@ -30,16 +32,16 @@ public class BlockLogicIce extends BlockLogicTransparent {
     }
 
     @Override
-    public void onHarvest(@NotNull World world, @NotNull Player player, @NotNull TilePos tilePos, int data, @Nullable TileEntity tileEntity) {
+    public void onHarvest(@NotNull World world, @NotNull Player player, @NotNull TilePosc tilePos, int data, @Nullable TileEntity tileEntity) {
         super.onHarvest(world, player, tilePos, data, tileEntity);
-        Material material = world.getBlockMaterial(tilePos.down());
+        Material material = world.getBlockMaterial(tilePos.down(new TilePos()));
         if(material.blocksMotion() || material.isLiquid()) {
             world.setBlockIdNotify(tilePos, Blocks.FLUID_WATER_FLOWING.id());
         }
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick)
+	public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick)
     {
         if(world.getSavedLightValue(LightLayer.Block, tilePos) > 11 - Blocks.lightBlock[id()])
         {
@@ -48,7 +50,7 @@ public class BlockLogicIce extends BlockLogicTransparent {
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos)
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos)
     {
         return Material.PISTON_PUSHABLE;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
index 5a7db4c3c..0614ba8e4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityFlowerJar;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
@@ -14,50 +15,50 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.block.ItemBlock;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.function.Supplier;
 
 public class BlockLogicJar extends BlockLogic implements ISupportable {
 
     private final @NotNull Supplier<@NotNull Item> itemSupplier;
+
     public BlockLogicJar(@NotNull Block<?> block, @NotNull Supplier<@NotNull Item> itemSupplier) {
-        super(block, Material.glass);
+        super(block, Materials.GLASS);
         block.withEntity(TileEntityFlowerJar::new);
         setBlockBounds(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.375f, 1 - 0.3125f);
         this.itemSupplier = itemSupplier;
     }
 
     @Override
-    public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         return isSupported(world, tilePos, Side.BOTTOM) && super.canPlaceAt(world, tilePos);
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
-        return AABB.fromPool(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.375f, 1 - 0.3125f);
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        return new AABBd(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.375f, 1 - 0.3125f);
     }
 
     @Override
-    public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return side == Side.BOTTOM ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
-        if(player.getHeldItem() == null) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+        if (player.getHeldItem() == null) {
             if (world.getBlockData(tilePos) == 0) {
                 world.setBlockIdNotify(tilePos, 0);
                 world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
@@ -85,12 +86,12 @@ public class BlockLogicJar extends BlockLogic implements ISupportable {
         } else if (player.getHeldItem().getItem() instanceof ItemBlock) {
             Block<?> blockInHand = ((ItemBlock<?>) player.getHeldItem().getItem()).getBlock();
             if (Blocks.hasTag(blockInHand.id(), BlockTags.PLANTABLE_IN_JAR) && world.getTileEntity(tilePos) instanceof TileEntityFlowerJar flowerJar) {
-                if(world.getBlockData(tilePos) == 0) {
+                if (world.getBlockData(tilePos) == 0) {
                     player.getHeldItem().consumeItem(player);
                     world.setBlockDataNotify(tilePos, 1);
                     flowerJar.flowerInPot = blockInHand.id();
                     flowerJar.flowerData = player.getHeldItem().getMetadata();
-                    world.playBlockSoundEffect(player, tilePos.x + 0.5f, tilePos.y + 0.5f, tilePos.z + 0.5f, this.block, EnumBlockSoundEffectType.PLACE);
+                    world.playBlockSoundEffect(player, tilePos.x() + 0.5f, tilePos.y() + 0.5f, tilePos.z() + 0.5f, this.block, EnumBlockSoundEffectType.PLACE);
                     return true;
                 } else if (blockInHand.getLogic() instanceof BlockLogicFlowerStackable && blockInHand == Blocks.getBlock(flowerJar.flowerInPot)) {
                     final int metadata = flowerJar.flowerData;
@@ -100,7 +101,7 @@ public class BlockLogicJar extends BlockLogic implements ISupportable {
                     }
 
                     flowerJar.flowerData = BlockLogicFlowerStackable.setPermanent(BlockLogicFlowerStackable.setStackCount(metadata, currentStackCount + 1), true);
-                    world.playBlockSoundEffect(player, tilePos.x + 0.5f, tilePos.y + 0.5f, tilePos.z + 0.5f, this.block, EnumBlockSoundEffectType.PLACE);
+                    world.playBlockSoundEffect(player, tilePos.x() + 0.5f, tilePos.y() + 0.5f, tilePos.z() + 0.5f, this.block, EnumBlockSoundEffectType.PLACE);
                     player.getHeldItem().consumeItem(player);
                     return true;
                 }
@@ -110,7 +111,7 @@ public class BlockLogicJar extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 
@@ -123,13 +124,12 @@ public class BlockLogicJar extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE.center();
     }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
index 0f35506cf..05eee30f7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityJarButterfly;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
@@ -13,12 +14,14 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.function.Supplier;
 
@@ -29,7 +32,7 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     private final @NotNull MobButterfly.ButterflyEntry color;
 
     public BlockLogicJarButterfly(@NotNull Block<?> block, @NotNull MobButterfly.ButterflyEntry color, @NotNull Supplier<@NotNull Item> itemSupplier) {
-        super(block, Material.glass);
+        super(block, Materials.GLASS);
         this.color = color;
         this.itemSupplier = itemSupplier;
         setBlockBounds(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.5f, 1 - 0.3125f);
@@ -37,12 +40,12 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int metadata = source.getBlockData(tilePos);
         float offset = 0.0F;
         if ((metadata & MASK_HANGING) != 0)
             offset = 0.3875F;
-        return AABB.fromPool(0.3125f, offset,  0.3125f, 1 - 0.3125f, 0.5F + offset, 1 - 0.3125f);
+        return new AABBd(0.3125f, offset, 0.3125f, 1 - 0.3125f, 0.5F + offset, 1 - 0.3125f);
     }
 
     @Override
@@ -56,12 +59,12 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         world.setBlockIdRaw(tilePos, 0);
         world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
         if (!world.isClientSide) {
@@ -73,8 +76,9 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
-        if ((side == Side.BOTTOM || (side != Side.TOP && yHit >= 0.5d)) && (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up()), BlockTags.CAN_HANG_OFF))) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
+        TilePos queryPos = new TilePos();
+        if ((side == Side.BOTTOM || (side != Side.TOP && yHit >= 0.5d)) && (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(queryPos)), BlockTags.CAN_HANG_OFF))) {
             world.setBlockDataNotify(tilePos, MASK_HANGING);
             return;
         }
@@ -82,7 +86,7 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
             world.setBlockDataNotify(tilePos, 0);
             return;
         }
-        if (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up()), BlockTags.CAN_HANG_OFF)) {
+        if (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(queryPos)), BlockTags.CAN_HANG_OFF)) {
             world.setBlockDataNotify(tilePos, MASK_HANGING);
         } else {
             world.setBlockDataNotify(tilePos, 0);
@@ -90,8 +94,8 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos) {
-        if (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up()), BlockTags.CAN_HANG_OFF)) {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF)) {
             return true;
         }
 
@@ -99,7 +103,7 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         if (!canStay(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
@@ -115,35 +119,35 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public boolean canStay(@NotNull World world, @NotNull TilePos tilePos) {
+    public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos) {
         int meta = world.getBlockData(tilePos);
         if ((meta & MASK_HANGING) != 0) {
-            return isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up()), BlockTags.CAN_HANG_OFF);
+            return isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF);
         }
 
         return isSupported(world, tilePos, Side.BOTTOM);
     }
 
     @Override
-    public void onDestroyedByPlayer(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, int data, @NotNull Player player, @Nullable Item item) {
+    public void onDestroyedByPlayer(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, int data, @NotNull Player player, @Nullable Item item) {
         if (item != null && item.isSilkTouch()) {
             return;
         }
         if (!world.isClientSide) {
             MobButterfly entity = new MobButterfly(world);
             entity.setColor(this.color.id);
-            entity.setPos(tilePos.x + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f, tilePos.y + world.rand.nextFloat() * 0.5f, tilePos.z + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f);
+            entity.setPos(tilePos.x() + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f, tilePos.y() + world.rand.nextFloat() * 0.5f, tilePos.z() + 0.5f + (world.rand.nextFloat() - 0.5f) * 0.5f);
             world.entityJoinedWorld(entity);
         }
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 
     @Override
-    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return side.isVertical() ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
index 3f41dbd2b..a546093c9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
@@ -3,23 +3,24 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityJukebox;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockLogicJukebox extends BlockLogic {
 	public BlockLogicJukebox(@NotNull Block<?> block) {
-        super(block, Material.wood);
+        super(block, Materials.WOOD);
         block.withEntity(TileEntityJukebox::new);
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if(world.getBlockData(tilePos) == 0) {
             return false;
         } else {
@@ -29,7 +30,7 @@ public class BlockLogicJukebox extends BlockLogic {
     }
 
     @Override
-    public void onActivatorInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
+    public void onActivatorInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
         if (world.getBlockData(tilePos) != 0) {
             ejectRecord(world, tilePos);
         }
@@ -43,13 +44,13 @@ public class BlockLogicJukebox extends BlockLogic {
         }
     }
 
-    public void ejectRecord(@NotNull World world, @NotNull TilePos tilePos)
+    public void ejectRecord(@NotNull World world, @NotNull TilePosc tilePos)
     {
         if(world.isClientSide)
         {
             return;
         }
         TileEntity tileEntity = world.getTileEntity(tilePos);
-        if (tileEntity != null) tileEntity.dropContents(world, tilePos.x, tilePos.y, tilePos.z);
+        if (tileEntity != null) tileEntity.dropContents(world, tilePos.x(), tilePos.y(), tilePos.z());
     }
 }
